/*
 *  hnv_cone.h
 *  HeteroNumberViewer
 *
 *  Created by Naoto Morikawa on 9/15/07.
 *  Copyright (C) 2007 Naoto Morikawa. All rights reserved.
 *
 *  2007-10-01 version 0.1 release
 */

//===============================================
// Public data
//===============================================

extern struct hnv_cone * my_standard_cone;
extern struct hnv_cone * my_standard_roof;
extern struct hnv_cone * my_conjugate_roof;


//===============================================
// Public methods
//===============================================

extern void copy_hnv_cone(struct hnv_cone * tgt_cone, struct hnv_cone * src_cone);
extern void load_peaks(struct hnv_cone * standard_cone, FILE * fp_file);
extern void print_hnv_cone(struct hnv_cone * std_cone);
extern void print_hnv_cone_short(struct hnv_cone * std_cone);
extern int get_cone_peak_ct(struct hnv_cone * std_cone);
extern void set_cone_peak_ct(struct hnv_cone * std_cone, int peak_ct);
extern int get_cone_peak_size(struct hnv_cone * std_cone);
extern int get_cone_dim(struct hnv_cone * std_cone);
extern HNV_PEAK_TYPE get_peak_redundance(struct hnv_cone * std_cone, int p_ct);
extern void set_peak_redundance(struct hnv_cone * std_cone, int p_ct, HNV_PEAK_TYPE value);
extern int get_peak_sum_mod3(struct hnv_cone * std_cone, int p_ct);
extern void set_peak_sum_mod3(struct hnv_cone * std_cone, int p_ct, int value);
extern void get_peak_coor(struct hnv_coor_4d * peak_coor, struct hnv_cone * std_cone, int p_ct);
extern void set_peak_coor(struct hnv_cone * std_cone, int p_ct, struct hnv_coor_4d * peak_coor);
extern struct hnv_cone * allocate_hnv_cone(int dim_ct, int peak_size);
extern struct hnv_cone * compute_expanded_cone(struct hnv_cone * std_cone);
extern struct hnv_cone * compute_conjugate_cone(struct hnv_cone * std_cone);
extern struct hnv_cone * compute_standard_cone(struct hnv_cone * conj_roof);
extern struct hnv_cone * compute_roof(struct hnv_cone * std_cone);
extern float height_std_peak(struct hnv_coor_4d * peak_point, struct hnv_coor_3d * pos);
extern float height_std_cone(struct hnv_cone * std_cone, struct hnv_coor_3d * position);
extern float height_conj_peak(struct hnv_coor_4d * peak_point, struct hnv_coor_3d * position);
extern float height_conj_cone(struct hnv_cone * conj_cone, struct hnv_coor_3d * position);
extern void remove_redundant_peaks(struct hnv_cone * std_cone);
extern void free_hnv_cone(struct hnv_cone * cone);
extern struct hnv_cone * compute_conjugate_roof(struct hnv_cone * std_cone);
