/*
 *  hnv_tetrahedron.h
 *  HeteroNumberViewer
 *
 *  Created by Naoto Morikawa on 9/15/07.
 *  Copyright (C) 2007 Naoto Morikawa. All rights reserved.
 *
 *  2007-10-01 version 0.1 release
 */

//===============================================
// Public data
//===============================================

extern struct tetrahedron bd_tetra_list_head;


//===============================================
// Public methods
//===============================================

extern void print_tetrahedron(struct tetrahedron * ft);
extern void print_tetra_list(struct tetrahedron * tetra);
extern int get_tetra_tetra_ct(struct tetrahedron * ft);
extern HNV_TETRA_CLASS get_tetra_class(struct tetrahedron * ft);
extern void set_tetra_class(struct tetrahedron * ft, HNV_TETRA_CLASS value);
extern void set_tetra_vertex(struct tetrahedron * ft, struct hnv_coor_3d * top, 
			     struct hnv_coor_3d * second, struct hnv_coor_3d * third, 
			     struct hnv_coor_3d * bottom);
extern void get_tetra_vertex(struct hnv_coor_3d * second, struct tetrahedron * ft, int ind);
extern int get_tetra_top_vertex(struct hnv_coor_3d * top, struct tetrahedron * ft);
extern void get_tetra_second_vertex(struct hnv_coor_3d * second, struct tetrahedron * ft);
extern void get_tetra_third_vertex(struct hnv_coor_3d * third, struct tetrahedron * ft);
extern int get_tetra_bottom_vertex(struct hnv_coor_3d * bottom, struct tetrahedron * ft);
extern void set_tetra_locator(struct tetrahedron * ft);
extern void get_tetra_locator(struct hnv_coor_3d_int * locator, struct tetrahedron * ft);
extern void set_tetra_direction(struct tetrahedron * ft, int value);
extern int get_tetra_direction(struct tetrahedron * ft);
extern HNV_GRADIENT get_tetra_gradient(struct tetrahedron * ft);
extern void set_tetra_gradient(struct tetrahedron * ft, HNV_GRADIENT value);
extern void set_tetra_nearby_peak(struct tetrahedron * ft, int peak_ct);
extern int get_tetra_nearby_peak(struct tetrahedron * ft);
extern void set_tetra_next_tetra(struct tetrahedron * ft, struct tetrahedron * ft_new);
extern struct tetrahedron * get_tetra_next_tetra(struct tetrahedron * ft);
extern void set_tetra_height(struct tetrahedron * ft, float height);
extern float get_tetra_height(struct tetrahedron * ft);
extern void copy_tetrahedron(struct tetrahedron * tgt_ft, struct tetrahedron * src_ft);
extern void order_tetra_vertices(struct tetrahedron * ft, float * height_std);
extern void set_up_empty_tetra_list(struct tetrahedron * list_head);
extern void fill_tetra_list(struct tetrahedron * list_head);
extern void initialize_tetra_pool(void);
extern void finalize_tetra_pool(void);
extern void put_tetrahedron(struct tetrahedron * list_head, struct tetrahedron * new_ft);
extern struct tetrahedron * take_tetrahedron(struct tetrahedron * list_head);
extern struct tetrahedron * assign_tetrahedron(void);
extern void recall_tetrahedron(struct tetrahedron * ft);
extern void compute_next_tetrahedron(struct tetrahedron * ft_tmp, struct tetrahedron * ft);
extern void compute_previous_tetrahedron(struct tetrahedron * ft_tmp, 
					 struct tetrahedron * ft);
